<?php
/**
 * InlineResponse20079ContentAllOfSoftwarelicensesInner
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20079ContentAllOfSoftwarelicensesInner Class Doc Comment
 *
 * @category Class
 * @description Describes a software license
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20079ContentAllOfSoftwarelicensesInner implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_79_content_allOf_softwarelicenses_inner';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'companyId' => 'int',
        'remark' => 'string',
        'internalRemark' => 'string',
        'serialNumber' => 'string',
        'inventoryNumber' => 'string',
        'softwarelicenseTypeId' => 'int',
        'expirationDate' => 'int',
        'renew' => 'bool',
        'date' => 'int',
        'maxNumberOfInstall' => 'int',
        'numberOfVolumes' => 'int',
        'active' => 'bool',
        'employeeId' => 'int',
        'articleNumber' => 'string',
        'contractPrice' => 'float'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'companyId' => null,
        'remark' => null,
        'internalRemark' => null,
        'serialNumber' => null,
        'inventoryNumber' => null,
        'softwarelicenseTypeId' => null,
        'expirationDate' => 'timestamp',
        'renew' => null,
        'date' => 'timestamp',
        'maxNumberOfInstall' => null,
        'numberOfVolumes' => null,
        'active' => null,
        'employeeId' => null,
        'articleNumber' => null,
        'contractPrice' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'companyId' => 'companyId',
        'remark' => 'remark',
        'internalRemark' => 'internalRemark',
        'serialNumber' => 'serialNumber',
        'inventoryNumber' => 'inventoryNumber',
        'softwarelicenseTypeId' => 'softwarelicenseTypeId',
        'expirationDate' => 'expirationDate',
        'renew' => 'renew',
        'date' => 'date',
        'maxNumberOfInstall' => 'maxNumberOfInstall',
        'numberOfVolumes' => 'numberOfVolumes',
        'active' => 'active',
        'employeeId' => 'employeeId',
        'articleNumber' => 'articleNumber',
        'contractPrice' => 'contractPrice'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'companyId' => 'setCompanyId',
        'remark' => 'setRemark',
        'internalRemark' => 'setInternalRemark',
        'serialNumber' => 'setSerialNumber',
        'inventoryNumber' => 'setInventoryNumber',
        'softwarelicenseTypeId' => 'setSoftwarelicenseTypeId',
        'expirationDate' => 'setExpirationDate',
        'renew' => 'setRenew',
        'date' => 'setDate',
        'maxNumberOfInstall' => 'setMaxNumberOfInstall',
        'numberOfVolumes' => 'setNumberOfVolumes',
        'active' => 'setActive',
        'employeeId' => 'setEmployeeId',
        'articleNumber' => 'setArticleNumber',
        'contractPrice' => 'setContractPrice'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'companyId' => 'getCompanyId',
        'remark' => 'getRemark',
        'internalRemark' => 'getInternalRemark',
        'serialNumber' => 'getSerialNumber',
        'inventoryNumber' => 'getInventoryNumber',
        'softwarelicenseTypeId' => 'getSoftwarelicenseTypeId',
        'expirationDate' => 'getExpirationDate',
        'renew' => 'getRenew',
        'date' => 'getDate',
        'maxNumberOfInstall' => 'getMaxNumberOfInstall',
        'numberOfVolumes' => 'getNumberOfVolumes',
        'active' => 'getActive',
        'employeeId' => 'getEmployeeId',
        'articleNumber' => 'getArticleNumber',
        'contractPrice' => 'getContractPrice'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
        $this->container['internalRemark'] = $data['internalRemark'] ?? null;
        $this->container['serialNumber'] = $data['serialNumber'] ?? null;
        $this->container['inventoryNumber'] = $data['inventoryNumber'] ?? null;
        $this->container['softwarelicenseTypeId'] = $data['softwarelicenseTypeId'] ?? null;
        $this->container['expirationDate'] = $data['expirationDate'] ?? null;
        $this->container['renew'] = $data['renew'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['maxNumberOfInstall'] = $data['maxNumberOfInstall'] ?? null;
        $this->container['numberOfVolumes'] = $data['numberOfVolumes'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['articleNumber'] = $data['articleNumber'] ?? null;
        $this->container['contractPrice'] = $data['contractPrice'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the software license
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId company id of the software license
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark misc. infos of for this software license
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }

    /**
     * Gets internalRemark
     *
     * @return string|null
     */
    public function getInternalRemark()
    {
        return $this->container['internalRemark'];
    }

    /**
     * Sets internalRemark
     *
     * @param string|null $internalRemark internal remarks of the license (can contain passwords), which only is seen by technicians or freelancers with the given permission
     *
     * @return self
     */
    public function setInternalRemark($internalRemark)
    {
        $this->container['internalRemark'] = $internalRemark;

        return $this;
    }

    /**
     * Gets serialNumber
     *
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->container['serialNumber'];
    }

    /**
     * Sets serialNumber
     *
     * @param string|null $serialNumber serial number
     *
     * @return self
     */
    public function setSerialNumber($serialNumber)
    {
        $this->container['serialNumber'] = $serialNumber;

        return $this;
    }

    /**
     * Gets inventoryNumber
     *
     * @return string|null
     */
    public function getInventoryNumber()
    {
        return $this->container['inventoryNumber'];
    }

    /**
     * Sets inventoryNumber
     *
     * @param string|null $inventoryNumber inventory number
     *
     * @return self
     */
    public function setInventoryNumber($inventoryNumber)
    {
        $this->container['inventoryNumber'] = $inventoryNumber;

        return $this;
    }

    /**
     * Gets softwarelicenseTypeId
     *
     * @return int|null
     */
    public function getSoftwarelicenseTypeId()
    {
        return $this->container['softwarelicenseTypeId'];
    }

    /**
     * Sets softwarelicenseTypeId
     *
     * @param int|null $softwarelicenseTypeId id of the sofware license type
     *
     * @return self
     */
    public function setSoftwarelicenseTypeId($softwarelicenseTypeId)
    {
        $this->container['softwarelicenseTypeId'] = $softwarelicenseTypeId;

        return $this;
    }

    /**
     * Gets expirationDate
     *
     * @return int|null
     */
    public function getExpirationDate()
    {
        return $this->container['expirationDate'];
    }

    /**
     * Sets expirationDate
     *
     * @param int|null $expirationDate date when the software license will expire
     *
     * @return self
     */
    public function setExpirationDate($expirationDate)
    {
        $this->container['expirationDate'] = $expirationDate;

        return $this;
    }

    /**
     * Gets renew
     *
     * @return bool|null
     */
    public function getRenew()
    {
        return $this->container['renew'];
    }

    /**
     * Sets renew
     *
     * @param bool|null $renew if true, the license must be renewed upon expiring and therefore needs further \"attention\"
     *
     * @return self
     */
    public function setRenew($renew)
    {
        $this->container['renew'] = $renew;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date starting date for this software license
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets maxNumberOfInstall
     *
     * @return int|null
     */
    public function getMaxNumberOfInstall()
    {
        return $this->container['maxNumberOfInstall'];
    }

    /**
     * Sets maxNumberOfInstall
     *
     * @param int|null $maxNumberOfInstall maximum number of installations
     *
     * @return self
     */
    public function setMaxNumberOfInstall($maxNumberOfInstall)
    {
        $this->container['maxNumberOfInstall'] = $maxNumberOfInstall;

        return $this;
    }

    /**
     * Gets numberOfVolumes
     *
     * @return int|null
     */
    public function getNumberOfVolumes()
    {
        return $this->container['numberOfVolumes'];
    }

    /**
     * Sets numberOfVolumes
     *
     * @param int|null $numberOfVolumes number of volumes (i.e. cds)
     *
     * @return self
     */
    public function setNumberOfVolumes($numberOfVolumes)
    {
        $this->container['numberOfVolumes'] = $numberOfVolumes;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active true if the software license is still active
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of employee which uses this software license
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets articleNumber
     *
     * @return string|null
     */
    public function getArticleNumber()
    {
        return $this->container['articleNumber'];
    }

    /**
     * Sets articleNumber
     *
     * @param string|null $articleNumber article number of the component
     *
     * @return self
     */
    public function setArticleNumber($articleNumber)
    {
        $this->container['articleNumber'] = $articleNumber;

        return $this;
    }

    /**
     * Gets contractPrice
     *
     * @return float|null
     */
    public function getContractPrice()
    {
        return $this->container['contractPrice'];
    }

    /**
     * Sets contractPrice
     *
     * @param float|null $contractPrice price which is used in maintenace contracts
     *
     * @return self
     */
    public function setContractPrice($contractPrice)
    {
        $this->container['contractPrice'] = $contractPrice;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


